// Verilog netlist produced by program LSE :  version Diamond (64-bit) 3.12.1.454
// Netlist written on Thu Sep 21 13:25:15 2023
//
// Verilog Description of module top
//

module top (Reset, Encoder1A_i, Encoder1B_i, Encoder1S_i, Encoder2A_i, 
            Encoder2B_i, Cathodes_o, Segments_o) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(4[8:11])
    input Reset;   // c:/lattice/kurs15/impl1/source/top.v(5[14:19])
    input Encoder1A_i;   // c:/lattice/kurs15/impl1/source/top.v(7[13:24])
    input Encoder1B_i;   // c:/lattice/kurs15/impl1/source/top.v(8[13:24])
    input Encoder1S_i;   // c:/lattice/kurs15/impl1/source/top.v(9[13:24])
    input Encoder2A_i;   // c:/lattice/kurs15/impl1/source/top.v(10[13:24])
    input Encoder2B_i;   // c:/lattice/kurs15/impl1/source/top.v(11[13:24])
    output [7:0]Cathodes_o;   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    output [7:0]Segments_o;   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    
    wire GND_net, VCC_net, Reset_c, Encoder1A_i_c_2, Encoder1B_i_c_1, 
        Encoder1S_i_c, Encoder2A_i_c_2, Encoder2B_i_c_1, Cathodes_o_c_7, 
        Cathodes_o_c_6, Cathodes_o_c_5, Cathodes_o_c_4, Cathodes_o_c_3, 
        Cathodes_o_c_2, Cathodes_o_c_1, Cathodes_o_c_0, Segments_o_c_7, 
        Segments_o_c_6, Segments_o_c_5, Segments_o_c_4, Segments_o_c_3, 
        Segments_o_c_2, Segments_o_c_1, Segments_o_c_0, AddressIncrement, 
        AddressDecrement, DataIncrement, DaraDecrement;
    wire [7:0]Address;   // c:/lattice/kurs15/impl1/source/top.v(63[12:19])
    wire [7:0]DataToWrite;   // c:/lattice/kurs15/impl1/source/top.v(75[12:23])
    wire [7:0]DataReadFromMemory;   // c:/lattice/kurs15/impl1/source/top.v(87[13:31])
    wire [7:0]Address_7__N_1;
    
    wire Reset_N_10;
    wire [7:0]DataToWrite_7__N_11;
    
    wire ButtonState_o, n1045, n1044, n1043, n241, Previous, n243, 
        n793, n792, n791, n790, n785, n784, n783, n782, n1042, 
        n185, n184, n183, n242;
    
    VHI i2 (.Z(VCC_net));
    OB Segments_o_pad_3 (.I(Segments_o_c_3), .O(Segments_o[3]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    FD1S3AX Address_i1 (.D(Address_7__N_1[1]), .CK(Clock), .Q(Address[1]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i1.GSR = "ENABLED";
    OSCH OSCH_inst (.STDBY(GND_net), .OSC(Clock)) /* synthesis syn_instantiated=1 */ ;
    defparam OSCH_inst.NOM_FREQ = "14.00";
    OB Cathodes_o_pad_3 (.I(Cathodes_o_c_3), .O(Cathodes_o[3]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    IB Encoder2A_i_pad (.I(Encoder2A_i), .O(Encoder2A_i_c_2));   // c:/lattice/kurs15/impl1/source/top.v(10[13:24])
    OB Cathodes_o_pad_4 (.I(Cathodes_o_c_4), .O(Cathodes_o[4]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    IB Encoder1S_i_pad (.I(Encoder1S_i), .O(Encoder1S_i_c));   // c:/lattice/kurs15/impl1/source/top.v(9[13:24])
    OB Cathodes_o_pad_5 (.I(Cathodes_o_c_5), .O(Cathodes_o[5]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    IB Encoder1B_i_pad (.I(Encoder1B_i), .O(Encoder1B_i_c_1));   // c:/lattice/kurs15/impl1/source/top.v(8[13:24])
    IB Encoder1A_i_pad (.I(Encoder1A_i), .O(Encoder1A_i_c_2));   // c:/lattice/kurs15/impl1/source/top.v(7[13:24])
    FD1S3AX DataToWrite_i7 (.D(DataToWrite_7__N_11[7]), .CK(Clock), .Q(DataToWrite[7]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i7.GSR = "ENABLED";
    FD1S3AX DataToWrite_i6 (.D(DataToWrite_7__N_11[6]), .CK(Clock), .Q(DataToWrite[6]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i6.GSR = "ENABLED";
    OB Segments_o_pad_7 (.I(Segments_o_c_7), .O(Segments_o[7]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    FD1S3AX DataToWrite_i5 (.D(DataToWrite_7__N_11[5]), .CK(Clock), .Q(DataToWrite[5]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i5.GSR = "ENABLED";
    FD1S3AX Address_i0 (.D(Address_7__N_1[0]), .CK(Clock), .Q(Address[0]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i0.GSR = "ENABLED";
    Encoder Encoder2 (.n240({Open_0, Open_1, n243, Open_2}), .n242(n242), 
            .n241(n241), .Clock(Clock), .DaraDecrement(DaraDecrement), 
            .n1043(n1043), .DataIncrement(DataIncrement), .n1044(n1044), 
            .Encoder2B_i_c_1(Encoder2B_i_c_1), .Encoder2A_i_c_2(Encoder2A_i_c_2)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(49[10] 60[3])
    VLO i1 (.Z(GND_net));
    OB Cathodes_o_pad_7 (.I(Cathodes_o_c_7), .O(Cathodes_o[7]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    CCU2D add_167_9 (.A0(DataToWrite[6]), .B0(DataIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(DataToWrite[7]), .B1(DataIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n793), .S0(DataToWrite_7__N_11[6]), .S1(DataToWrite_7__N_11[7]));   // c:/lattice/kurs15/impl1/source/top.v(82[8] 83[38])
    defparam add_167_9.INIT0 = 16'h5999;
    defparam add_167_9.INIT1 = 16'h5999;
    defparam add_167_9.INJECT1_0 = "NO";
    defparam add_167_9.INJECT1_1 = "NO";
    CCU2D add_167_7 (.A0(DataToWrite[4]), .B0(DataIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(DataToWrite[5]), .B1(DataIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n792), .COUT(n793), .S0(DataToWrite_7__N_11[4]), 
          .S1(DataToWrite_7__N_11[5]));   // c:/lattice/kurs15/impl1/source/top.v(82[8] 83[38])
    defparam add_167_7.INIT0 = 16'h5999;
    defparam add_167_7.INIT1 = 16'h5999;
    defparam add_167_7.INJECT1_0 = "NO";
    defparam add_167_7.INJECT1_1 = "NO";
    GSR GSR_INST (.GSR(Reset_c));
    FD1S3AX DataToWrite_i4 (.D(DataToWrite_7__N_11[4]), .CK(Clock), .Q(DataToWrite[4]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i4.GSR = "ENABLED";
    FD1S3AX DataToWrite_i3 (.D(DataToWrite_7__N_11[3]), .CK(Clock), .Q(DataToWrite[3]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i3.GSR = "ENABLED";
    FD1S3AX DataToWrite_i2 (.D(DataToWrite_7__N_11[2]), .CK(Clock), .Q(DataToWrite[2]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i2.GSR = "ENABLED";
    FD1S3AX DataToWrite_i0 (.D(DataToWrite_7__N_11[0]), .CK(Clock), .Q(DataToWrite[0]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i0.GSR = "ENABLED";
    CCU2D add_167_5 (.A0(DataToWrite[2]), .B0(DataIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(DataToWrite[3]), .B1(DataIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n791), .COUT(n792), .S0(DataToWrite_7__N_11[2]), 
          .S1(DataToWrite_7__N_11[3]));   // c:/lattice/kurs15/impl1/source/top.v(82[8] 83[38])
    defparam add_167_5.INIT0 = 16'h5999;
    defparam add_167_5.INIT1 = 16'h5999;
    defparam add_167_5.INJECT1_0 = "NO";
    defparam add_167_5.INJECT1_1 = "NO";
    CCU2D add_167_3 (.A0(DataIncrement), .B0(DaraDecrement), .C0(DataToWrite[0]), 
          .D0(GND_net), .A1(DataToWrite[1]), .B1(DataIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n790), .COUT(n791), .S0(DataToWrite_7__N_11[0]), 
          .S1(DataToWrite_7__N_11[1]));   // c:/lattice/kurs15/impl1/source/top.v(82[8] 83[38])
    defparam add_167_3.INIT0 = 16'h4b4b;
    defparam add_167_3.INIT1 = 16'h5999;
    defparam add_167_3.INJECT1_0 = "NO";
    defparam add_167_3.INJECT1_1 = "NO";
    CCU2D add_167_1 (.A0(GND_net), .B0(GND_net), .C0(GND_net), .D0(GND_net), 
          .A1(DataIncrement), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .COUT(n790));   // c:/lattice/kurs15/impl1/source/top.v(82[8] 83[38])
    defparam add_167_1.INIT0 = 16'hF000;
    defparam add_167_1.INIT1 = 16'h0aaa;
    defparam add_167_1.INJECT1_0 = "NO";
    defparam add_167_1.INJECT1_1 = "NO";
    TSALL TSALL_INST (.TSALL(GND_net));
    CCU2D add_171_9 (.A0(Address[6]), .B0(AddressIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(Address[7]), .B1(AddressIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n785), .S0(Address_7__N_1[6]), .S1(Address_7__N_1[7]));   // c:/lattice/kurs15/impl1/source/top.v(70[8] 71[30])
    defparam add_171_9.INIT0 = 16'h5999;
    defparam add_171_9.INIT1 = 16'h5999;
    defparam add_171_9.INJECT1_0 = "NO";
    defparam add_171_9.INJECT1_1 = "NO";
    CCU2D add_171_7 (.A0(Address[4]), .B0(AddressIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(Address[5]), .B1(AddressIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n784), .COUT(n785), .S0(Address_7__N_1[4]), 
          .S1(Address_7__N_1[5]));   // c:/lattice/kurs15/impl1/source/top.v(70[8] 71[30])
    defparam add_171_7.INIT0 = 16'h5999;
    defparam add_171_7.INIT1 = 16'h5999;
    defparam add_171_7.INJECT1_0 = "NO";
    defparam add_171_7.INJECT1_1 = "NO";
    CCU2D add_171_5 (.A0(Address[2]), .B0(AddressIncrement), .C0(GND_net), 
          .D0(GND_net), .A1(Address[3]), .B1(AddressIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n783), .COUT(n784), .S0(Address_7__N_1[2]), 
          .S1(Address_7__N_1[3]));   // c:/lattice/kurs15/impl1/source/top.v(70[8] 71[30])
    defparam add_171_5.INIT0 = 16'h5999;
    defparam add_171_5.INIT1 = 16'h5999;
    defparam add_171_5.INJECT1_0 = "NO";
    defparam add_171_5.INJECT1_1 = "NO";
    CCU2D add_171_3 (.A0(AddressIncrement), .B0(AddressDecrement), .C0(Address[0]), 
          .D0(GND_net), .A1(Address[1]), .B1(AddressIncrement), .C1(GND_net), 
          .D1(GND_net), .CIN(n782), .COUT(n783), .S0(Address_7__N_1[0]), 
          .S1(Address_7__N_1[1]));   // c:/lattice/kurs15/impl1/source/top.v(70[8] 71[30])
    defparam add_171_3.INIT0 = 16'h4b4b;
    defparam add_171_3.INIT1 = 16'h5999;
    defparam add_171_3.INJECT1_0 = "NO";
    defparam add_171_3.INJECT1_1 = "NO";
    CCU2D add_171_1 (.A0(GND_net), .B0(GND_net), .C0(GND_net), .D0(GND_net), 
          .A1(AddressIncrement), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .COUT(n782));   // c:/lattice/kurs15/impl1/source/top.v(70[8] 71[30])
    defparam add_171_1.INIT0 = 16'hF000;
    defparam add_171_1.INIT1 = 16'h0aaa;
    defparam add_171_1.INJECT1_0 = "NO";
    defparam add_171_1.INJECT1_1 = "NO";
    \DisplayMultiplex(CLOCK_HZ=14000000)  DisplayMultiplex_inst (.Cathodes_o_c_6(Cathodes_o_c_6), 
            .Cathodes_o_c_4(Cathodes_o_c_4), .Cathodes_o_c_7(Cathodes_o_c_7), 
            .Cathodes_o_c_5(Cathodes_o_c_5), .Segments_o_c_7(Segments_o_c_7), 
            .DataReadFromMemory({DataReadFromMemory}), .DataToWrite({DataToWrite}), 
            .Clock(Clock), .Address({Address}), .Cathodes_o_c_2(Cathodes_o_c_2), 
            .Cathodes_o_c_3(Cathodes_o_c_3), .Cathodes_o_c_0(Cathodes_o_c_0), 
            .Cathodes_o_c_1(Cathodes_o_c_1), .Reset_c(Reset_c), .Reset_N_10(Reset_N_10), 
            .GND_net(GND_net), .Segments_o_c_6(Segments_o_c_6), .Segments_o_c_3(Segments_o_c_3), 
            .Segments_o_c_0(Segments_o_c_0), .Segments_o_c_2(Segments_o_c_2), 
            .Segments_o_c_4(Segments_o_c_4), .Segments_o_c_5(Segments_o_c_5), 
            .Segments_o_c_1(Segments_o_c_1)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(107[4] 115[3])
    OB Cathodes_o_pad_6 (.I(Cathodes_o_c_6), .O(Cathodes_o[6]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    FD1S3AX Address_i7 (.D(Address_7__N_1[7]), .CK(Clock), .Q(Address[7]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i7.GSR = "ENABLED";
    FD1S3AX Address_i6 (.D(Address_7__N_1[6]), .CK(Clock), .Q(Address[6]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i6.GSR = "ENABLED";
    FD1S3AX Address_i5 (.D(Address_7__N_1[5]), .CK(Clock), .Q(Address[5]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i5.GSR = "ENABLED";
    FD1S3AX Address_i4 (.D(Address_7__N_1[4]), .CK(Clock), .Q(Address[4]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i4.GSR = "ENABLED";
    FD1S3AX Address_i3 (.D(Address_7__N_1[3]), .CK(Clock), .Q(Address[3]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i3.GSR = "ENABLED";
    FD1S3AX Address_i2 (.D(Address_7__N_1[2]), .CK(Clock), .Q(Address[2]));   // c:/lattice/kurs15/impl1/source/top.v(68[8] 71[30])
    defparam Address_i2.GSR = "ENABLED";
    IB Encoder2B_i_pad (.I(Encoder2B_i), .O(Encoder2B_i_c_1));   // c:/lattice/kurs15/impl1/source/top.v(11[13:24])
    IB Reset_pad (.I(Reset), .O(Reset_c));   // c:/lattice/kurs15/impl1/source/top.v(5[14:19])
    OB Segments_o_pad_0 (.I(Segments_o_c_0), .O(Segments_o[0]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    OB Segments_o_pad_1 (.I(Segments_o_c_1), .O(Segments_o[1]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    OB Segments_o_pad_2 (.I(Segments_o_c_2), .O(Segments_o[2]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    LUT4 i812_4_lut (.A(AddressDecrement), .B(n183), .C(n185), .Z(n1042)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i812_4_lut.init = 16'hfefe;
    Encoder_U1 Encoder1 (.n182({n183, Open_3, n185, Open_4}), .Clock(Clock), 
            .Encoder1S_i_c(Encoder1S_i_c), .n184(n184), .AddressDecrement(AddressDecrement), 
            .n1042(n1042), .AddressIncrement(AddressIncrement), .n1045(n1045), 
            .ButtonState_o(ButtonState_o), .Encoder1A_i_c_2(Encoder1A_i_c_2), 
            .Encoder1B_i_c_1(Encoder1B_i_c_1), .Previous(Previous)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(32[10] 43[3])
    LUT4 i813_4_lut (.A(DaraDecrement), .B(n241), .C(n243), .Z(n1043)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i813_4_lut.init = 16'hfefe;
    LUT4 i814_4_lut (.A(DataIncrement), .B(n241), .C(n242), .Z(n1044)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i814_4_lut.init = 16'hfefe;
    OB Segments_o_pad_4 (.I(Segments_o_c_4), .O(Segments_o[4]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    OB Cathodes_o_pad_0 (.I(Cathodes_o_c_0), .O(Cathodes_o[0]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    OB Segments_o_pad_5 (.I(Segments_o_c_5), .O(Segments_o[5]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    OB Cathodes_o_pad_1 (.I(Cathodes_o_c_1), .O(Cathodes_o[1]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    OB Segments_o_pad_6 (.I(Segments_o_c_6), .O(Segments_o[6]));   // c:/lattice/kurs15/impl1/source/top.v(13[20:30])
    FD1S3AX DataToWrite_i1 (.D(DataToWrite_7__N_11[1]), .CK(Clock), .Q(DataToWrite[1]));   // c:/lattice/kurs15/impl1/source/top.v(80[8] 83[38])
    defparam DataToWrite_i1.GSR = "ENABLED";
    OB Cathodes_o_pad_2 (.I(Cathodes_o_c_2), .O(Cathodes_o[2]));   // c:/lattice/kurs15/impl1/source/top.v(12[20:30])
    LUT4 i815_4_lut (.A(AddressIncrement), .B(n183), .C(n184), .Z(n1045)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i815_4_lut.init = 16'hfefe;
    PUR PUR_INST (.PUR(VCC_net));
    defparam PUR_INST.RST_PULSE = 1;
    \RAM(ADDRESS_WIDTH=8)  RAM_inst (.Address({Address}), .DataToWrite({DataToWrite}), 
            .DataReadFromMemory({DataReadFromMemory}), .Clock(Clock), .VCC_net(VCC_net), 
            .Reset_N_10(Reset_N_10), .GND_net(GND_net), .ButtonState_o(ButtonState_o), 
            .Previous(Previous), .Reset_c(Reset_c)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(92[4] 100[3])
    
endmodule
//
// Verilog Description of module Encoder
//

module Encoder (n240, n242, n241, Clock, DaraDecrement, n1043, DataIncrement, 
            n1044, Encoder2B_i_c_1, Encoder2A_i_c_2) /* synthesis syn_module_defined=1 */ ;
    output [3:0]n240;
    output n242;
    output n241;
    input Clock;
    output DaraDecrement;
    input n1043;
    output DataIncrement;
    input n1044;
    input Encoder2B_i_c_1;
    input Encoder2A_i_c_2;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [3:0]n240_c;
    
    wire n971;
    wire [2:0]Sync_o;   // c:/lattice/kurs15/impl1/source/synchronizer.v(10[26:32])
    
    wire n1181, n611, Increment_o_N_63, n914, n920, n605, n1179, 
        n1180;
    
    LUT4 i2_3_lut (.A(n240[1]), .B(n240_c[0]), .C(n242), .Z(n971)) /* synthesis lut_function=(A+(B+(C))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i2_3_lut.init = 16'hfefe;
    LUT4 i1_4_lut (.A(Sync_o[2]), .B(n1181), .C(n241), .D(Sync_o[1]), 
         .Z(n611)) /* synthesis lut_function=(A (B+(C (D)))+!A (B)) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut.init = 16'heccc;
    LUT4 i849_2_lut (.A(Sync_o[2]), .B(Sync_o[1]), .Z(Increment_o_N_63)) /* synthesis lut_function=(!(A+(B))) */ ;
    defparam i849_2_lut.init = 16'h1111;
    LUT4 i1_4_lut_adj_10 (.A(n240_c[0]), .B(n242), .C(Sync_o[1]), .D(Sync_o[2]), 
         .Z(n914)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B ((D)+!C))+!A ((C (D)+!C !(D))+!B))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_10.init = 16'h0ce0;
    LUT4 i1_4_lut_adj_11 (.A(n240_c[0]), .B(n240[1]), .C(Sync_o[1]), .D(Sync_o[2]), 
         .Z(n920)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B (C+!(D)))+!A ((C (D)+!C !(D))+!B))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_11.init = 16'h0ec0;
    FD1S3AY State_FSM_i0 (.D(n611), .CK(Clock), .Q(n240_c[0]));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i0.GSR = "ENABLED";
    FD1S3AX State_FSM_i3 (.D(n605), .CK(Clock), .Q(n241));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i3.GSR = "ENABLED";
    FD1S3AX State_FSM_i2 (.D(n914), .CK(Clock), .Q(n242));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i2.GSR = "ENABLED";
    FD1S3AX State_FSM_i1 (.D(n920), .CK(Clock), .Q(n240[1]));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i1.GSR = "ENABLED";
    FD1P3IX Decrement_o_40 (.D(n1043), .SP(Increment_o_N_63), .CD(n241), 
            .CK(Clock), .Q(DaraDecrement)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=10, LSE_RCOL=3, LSE_LLINE=49, LSE_RLINE=60 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(45[12] 85[6])
    defparam Decrement_o_40.GSR = "ENABLED";
    FD1P3IX Increment_o_39 (.D(n1044), .SP(Increment_o_N_63), .CD(n241), 
            .CK(Clock), .Q(DataIncrement)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=10, LSE_RCOL=3, LSE_LLINE=49, LSE_RLINE=60 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(45[12] 85[6])
    defparam Increment_o_39.GSR = "ENABLED";
    PFUMX i894 (.BLUT(n1179), .ALUT(n1180), .C0(n242), .Z(n1181));
    LUT4 i1_4_lut_then_2_lut (.A(Sync_o[2]), .B(Sync_o[1]), .Z(n1180)) /* synthesis lut_function=(A (B)) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(53[15] 55[9])
    defparam i1_4_lut_then_2_lut.init = 16'h8888;
    LUT4 i1_4_lut_else_2_lut (.A(Sync_o[2]), .B(n240_c[0]), .C(Sync_o[1]), 
         .D(n240[1]), .Z(n1179)) /* synthesis lut_function=(A (B (C)+!B (C (D)))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(53[15] 55[9])
    defparam i1_4_lut_else_2_lut.init = 16'ha080;
    LUT4 i1_4_lut_adj_12 (.A(n241), .B(Sync_o[1]), .C(Sync_o[2]), .D(n971), 
         .Z(n605)) /* synthesis lut_function=(!(A (B (C))+!A (B+(C+!(D))))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_12.init = 16'h2b2a;
    \Synchronizer(WIDTH=3)  SynchronizerA (.B(Sync_o[1]), .Clock(Clock), 
            .Encoder2B_i_c_1(Encoder2B_i_c_1), .Encoder2A_i_c_2(Encoder2A_i_c_2), 
            .A(Sync_o[2])) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(25[4] 30[3])
    
endmodule
//
// Verilog Description of module \Synchronizer(WIDTH=3) 
//

module \Synchronizer(WIDTH=3)  (B, Clock, Encoder2B_i_c_1, Encoder2A_i_c_2, 
            A) /* synthesis syn_module_defined=1 */ ;
    output B;
    input Clock;
    input Encoder2B_i_c_1;
    input Encoder2A_i_c_2;
    output A;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [2:0]R1;   // c:/lattice/kurs15/impl1/source/synchronizer.v(13[18:20])
    
    FD1S3AX R2_i1 (.D(R1[1]), .CK(Clock), .Q(B)) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R2_i1.GSR = "ENABLED";
    FD1S3AX R1_i1 (.D(Encoder2B_i_c_1), .CK(Clock), .Q(R1[1])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R1_i1.GSR = "ENABLED";
    FD1S3AX R1_i2 (.D(Encoder2A_i_c_2), .CK(Clock), .Q(R1[2])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R1_i2.GSR = "ENABLED";
    FD1S3AX R2_i2 (.D(R1[2]), .CK(Clock), .Q(A)) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R2_i2.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module TSALL
// module not written out since it is a black-box. 
//

//
// Verilog Description of module \DisplayMultiplex(CLOCK_HZ=14000000) 
//

module \DisplayMultiplex(CLOCK_HZ=14000000)  (Cathodes_o_c_6, Cathodes_o_c_4, 
            Cathodes_o_c_7, Cathodes_o_c_5, Segments_o_c_7, DataReadFromMemory, 
            DataToWrite, Clock, Address, Cathodes_o_c_2, Cathodes_o_c_3, 
            Cathodes_o_c_0, Cathodes_o_c_1, Reset_c, Reset_N_10, GND_net, 
            Segments_o_c_6, Segments_o_c_3, Segments_o_c_0, Segments_o_c_2, 
            Segments_o_c_4, Segments_o_c_5, Segments_o_c_1) /* synthesis syn_module_defined=1 */ ;
    output Cathodes_o_c_6;
    output Cathodes_o_c_4;
    output Cathodes_o_c_7;
    output Cathodes_o_c_5;
    output Segments_o_c_7;
    input [7:0]DataReadFromMemory;
    input [7:0]DataToWrite;
    input Clock;
    input [7:0]Address;
    output Cathodes_o_c_2;
    output Cathodes_o_c_3;
    output Cathodes_o_c_0;
    output Cathodes_o_c_1;
    input Reset_c;
    output Reset_N_10;
    input GND_net;
    output Segments_o_c_6;
    output Segments_o_c_3;
    output Segments_o_c_0;
    output Segments_o_c_2;
    output Segments_o_c_4;
    output Segments_o_c_5;
    output Segments_o_c_1;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [31:0]TempData_3__N_110;
    
    wire n1128, n1030;
    wire [3:0]TempData;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(60[13:21])
    
    wire n1145, n1036, n1123, n1122, n1124, n1019, n948, n37, 
        n1148, n1039, n1028, n45, n1020, SwitchCathode_o, n1178, 
        Visible_6__N_100;
    wire [2:0]n17;
    
    wire n1011, Visible_6__N_103, Visible_6__N_101, n1121, n1022, 
        n1024, n1126, n1127, n1146, n1147, n1143, n1144;
    
    LUT4 i1_2_lut_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_6)) /* synthesis lut_function=(!(((C)+!B)+!A)) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i1_2_lut_2_lut_3_lut.init = 16'h0808;
    LUT4 Data_i_31__I_0_i281_3_lut_4_lut (.A(TempData_3__N_110[4]), .B(TempData_3__N_110[3]), 
         .C(n1128), .D(n1030), .Z(TempData[0])) /* synthesis lut_function=(A (C)+!A (B (C)+!B (D))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(60[30:49])
    defparam Data_i_31__I_0_i281_3_lut_4_lut.init = 16'hf1e0;
    LUT4 i852_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_4)) /* synthesis lut_function=(!(A+((C)+!B))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i852_2_lut_3_lut.init = 16'h0404;
    LUT4 Data_i_31__I_0_i282_3_lut_4_lut (.A(TempData_3__N_110[4]), .B(TempData_3__N_110[3]), 
         .C(n1145), .D(n1036), .Z(TempData[1])) /* synthesis lut_function=(A (C)+!A (B (C)+!B (D))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(60[30:49])
    defparam Data_i_31__I_0_i282_3_lut_4_lut.init = 16'hf1e0;
    LUT4 i1_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_7)) /* synthesis lut_function=(A (B (C))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i1_2_lut_3_lut.init = 16'h8080;
    LUT4 i455_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_5)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i455_2_lut_3_lut.init = 16'h4040;
    LUT4 i448_3_lut (.A(TempData_3__N_110[2]), .B(TempData_3__N_110[3]), 
         .C(TempData_3__N_110[4]), .Z(Segments_o_c_7)) /* synthesis lut_function=(!(A+(B (C)+!B !(C)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(66[41:49])
    defparam i448_3_lut.init = 16'h1414;
    LUT4 DataReadFromMemory_3__bdd_3_lut_898 (.A(DataReadFromMemory[3]), .B(TempData_3__N_110[2]), 
         .C(DataReadFromMemory[7]), .Z(n1123)) /* synthesis lut_function=(A ((C)+!B)+!A (B (C))) */ ;
    defparam DataReadFromMemory_3__bdd_3_lut_898.init = 16'he2e2;
    LUT4 i806_3_lut (.A(DataReadFromMemory[1]), .B(DataReadFromMemory[5]), 
         .C(TempData_3__N_110[2]), .Z(n1036)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i806_3_lut.init = 16'hcaca;
    PFUMX i873 (.BLUT(n1123), .ALUT(n1122), .C0(TempData_3__N_110[4]), 
          .Z(n1124));
    LUT4 i1_4_lut (.A(TempData_3__N_110[4]), .B(n1019), .C(TempData_3__N_110[3]), 
         .D(n948), .Z(n37)) /* synthesis lut_function=(A (B+(C+!(D)))+!A (B)) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(66[41:49])
    defparam i1_4_lut.init = 16'hecee;
    LUT4 Data_i_31__I_0_i283_3_lut_4_lut (.A(TempData_3__N_110[4]), .B(TempData_3__N_110[3]), 
         .C(n1148), .D(n1039), .Z(TempData[2])) /* synthesis lut_function=(A (C)+!A (B (C)+!B (D))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(60[30:49])
    defparam Data_i_31__I_0_i283_3_lut_4_lut.init = 16'hf1e0;
    LUT4 i6_4_lut (.A(n1028), .B(n45), .C(n1020), .D(DataToWrite[4]), 
         .Z(n1019)) /* synthesis lut_function=(!(A+((C+(D))+!B))) */ ;
    defparam i6_4_lut.init = 16'h0004;
    LUT4 i809_3_lut (.A(DataReadFromMemory[2]), .B(DataReadFromMemory[6]), 
         .C(TempData_3__N_110[2]), .Z(n1039)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i809_3_lut.init = 16'hcaca;
    FD1P3AX Selector_209__i1 (.D(n1178), .SP(SwitchCathode_o), .CK(Clock), 
            .Q(TempData_3__N_110[2]));   // c:/lattice/kurs15/impl1/source/display_multiplex.v(52[17:32])
    defparam Selector_209__i1.GSR = "ENABLED";
    LUT4 i798_3_lut (.A(DataToWrite[7]), .B(DataToWrite[6]), .C(Visible_6__N_100), 
         .Z(n1028)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i798_3_lut.init = 16'hfefe;
    LUT4 i800_3_lut (.A(DataReadFromMemory[0]), .B(DataReadFromMemory[4]), 
         .C(TempData_3__N_110[2]), .Z(n1030)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i800_3_lut.init = 16'hcaca;
    FD1P3AX Selector_209__i3 (.D(n17[2]), .SP(SwitchCathode_o), .CK(Clock), 
            .Q(TempData_3__N_110[4]));   // c:/lattice/kurs15/impl1/source/display_multiplex.v(52[17:32])
    defparam Selector_209__i3.GSR = "ENABLED";
    FD1P3AX Selector_209__i2 (.D(n17[1]), .SP(SwitchCathode_o), .CK(Clock), 
            .Q(TempData_3__N_110[3]));   // c:/lattice/kurs15/impl1/source/display_multiplex.v(52[17:32])
    defparam Selector_209__i2.GSR = "ENABLED";
    LUT4 i1_4_lut_adj_5 (.A(n1011), .B(TempData_3__N_110[3]), .C(TempData_3__N_110[2]), 
         .D(Visible_6__N_103), .Z(n45)) /* synthesis lut_function=(A+(B (C+!(D)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(66[41:49])
    defparam i1_4_lut_adj_5.init = 16'heaee;
    LUT4 i790_2_lut (.A(DataToWrite[5]), .B(Visible_6__N_101), .Z(n1020)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i790_2_lut.init = 16'heeee;
    LUT4 TempData_3__N_110_3__bdd_4_lut_875 (.A(DataToWrite[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .D(DataToWrite[7]), .Z(n1121)) /* synthesis lut_function=(!(A (B+!((D)+!C))+!A (B+!(C (D))))) */ ;
    defparam TempData_3__N_110_3__bdd_4_lut_875.init = 16'h3202;
    LUT4 i255_1_lut_rep_22 (.A(TempData_3__N_110[2]), .Z(n1178)) /* synthesis lut_function=(!(A)) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(66[41:49])
    defparam i255_1_lut_rep_22.init = 16'h5555;
    LUT4 i5_4_lut (.A(n1022), .B(DataReadFromMemory[7]), .C(n1024), .D(TempData_3__N_110[2]), 
         .Z(n1011)) /* synthesis lut_function=(!(A+(B+(C+!(D))))) */ ;
    defparam i5_4_lut.init = 16'h0100;
    LUT4 i792_2_lut (.A(DataReadFromMemory[4]), .B(DataReadFromMemory[5]), 
         .Z(n1022)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i792_2_lut.init = 16'heeee;
    LUT4 i794_2_lut (.A(Visible_6__N_103), .B(DataReadFromMemory[6]), .Z(n1024)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i794_2_lut.init = 16'heeee;
    LUT4 i3_4_lut (.A(DataToWrite[0]), .B(DataToWrite[3]), .C(DataToWrite[2]), 
         .D(DataToWrite[1]), .Z(Visible_6__N_103)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(26[34:52])
    defparam i3_4_lut.init = 16'hfffe;
    LUT4 i3_4_lut_adj_6 (.A(Address[0]), .B(Address[3]), .C(Address[2]), 
         .D(Address[1]), .Z(Visible_6__N_101)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(26[34:52])
    defparam i3_4_lut_adj_6.init = 16'hfffe;
    LUT4 i3_4_lut_adj_7 (.A(Address[4]), .B(Address[7]), .C(Address[6]), 
         .D(Address[5]), .Z(Visible_6__N_100)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(26[34:52])
    defparam i3_4_lut_adj_7.init = 16'hfffe;
    LUT4 i1_2_lut_2_lut_3_lut_adj_8 (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_2)) /* synthesis lut_function=(!((B+(C))+!A)) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i1_2_lut_2_lut_3_lut_adj_8.init = 16'h0202;
    LUT4 i1_2_lut_3_lut_adj_9 (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_3)) /* synthesis lut_function=(!((B+!(C))+!A)) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i1_2_lut_3_lut_adj_9.init = 16'h2020;
    LUT4 n1124_bdd_3_lut (.A(n1124), .B(n1121), .C(TempData_3__N_110[3]), 
         .Z(TempData[3])) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam n1124_bdd_3_lut.init = 16'hcaca;
    LUT4 i718_3_lut_3_lut (.A(TempData_3__N_110[2]), .B(Visible_6__N_101), 
         .C(Visible_6__N_100), .Z(n948)) /* synthesis lut_function=(A (C)+!A (B+(C))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(66[41:49])
    defparam i718_3_lut_3_lut.init = 16'hf4f4;
    LUT4 TempData_3__N_110_3__bdd_4_lut_878 (.A(TempData_3__N_110[3]), .B(Address[0]), 
         .C(Address[4]), .D(TempData_3__N_110[2]), .Z(n1126)) /* synthesis lut_function=(!(A+!(B (C+!(D))+!B (C (D))))) */ ;
    defparam TempData_3__N_110_3__bdd_4_lut_878.init = 16'h5044;
    LUT4 TempData_3__N_110_3__bdd_3_lut_879 (.A(DataToWrite[0]), .B(TempData_3__N_110[2]), 
         .C(DataToWrite[4]), .Z(n1127)) /* synthesis lut_function=(A ((C)+!B)+!A (B (C))) */ ;
    defparam TempData_3__N_110_3__bdd_3_lut_879.init = 16'he2e2;
    LUT4 TempData_3__N_110_3__bdd_4_lut (.A(TempData_3__N_110[3]), .B(Address[2]), 
         .C(Address[6]), .D(TempData_3__N_110[2]), .Z(n1146)) /* synthesis lut_function=(!(A+!(B (C+!(D))+!B (C (D))))) */ ;
    defparam TempData_3__N_110_3__bdd_4_lut.init = 16'h5044;
    LUT4 TempData_3__N_110_3__bdd_3_lut (.A(DataToWrite[2]), .B(TempData_3__N_110[2]), 
         .C(DataToWrite[6]), .Z(n1147)) /* synthesis lut_function=(A ((C)+!B)+!A (B (C))) */ ;
    defparam TempData_3__N_110_3__bdd_3_lut.init = 16'he2e2;
    PFUMX i884 (.BLUT(n1147), .ALUT(n1146), .C0(TempData_3__N_110[4]), 
          .Z(n1148));
    LUT4 i556_3_lut (.A(TempData_3__N_110[4]), .B(TempData_3__N_110[3]), 
         .C(TempData_3__N_110[2]), .Z(n17[2])) /* synthesis lut_function=(!(A (B (C))+!A !(B (C)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(52[17:32])
    defparam i556_3_lut.init = 16'h6a6a;
    LUT4 i862_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_0)) /* synthesis lut_function=(!(A+(B+(C)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i862_2_lut_3_lut.init = 16'h0101;
    LUT4 i549_2_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[2]), 
         .Z(n17[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(52[17:32])
    defparam i549_2_lut.init = 16'h6666;
    LUT4 i447_2_lut_3_lut (.A(TempData_3__N_110[3]), .B(TempData_3__N_110[4]), 
         .C(TempData_3__N_110[2]), .Z(Cathodes_o_c_1)) /* synthesis lut_function=(!(A+(B+!(C)))) */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(57[22:40])
    defparam i447_2_lut_3_lut.init = 16'h1010;
    LUT4 TempData_3__N_110_3__bdd_4_lut_882 (.A(TempData_3__N_110[3]), .B(Address[1]), 
         .C(Address[5]), .D(TempData_3__N_110[2]), .Z(n1143)) /* synthesis lut_function=(!(A+!(B (C+!(D))+!B (C (D))))) */ ;
    defparam TempData_3__N_110_3__bdd_4_lut_882.init = 16'h5044;
    PFUMX i880 (.BLUT(n1144), .ALUT(n1143), .C0(TempData_3__N_110[4]), 
          .Z(n1145));
    LUT4 DataReadFromMemory_3__bdd_3_lut_872 (.A(Address[3]), .B(Address[7]), 
         .C(TempData_3__N_110[2]), .Z(n1122)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam DataReadFromMemory_3__bdd_3_lut_872.init = 16'hcaca;
    LUT4 TempData_3__N_110_3__bdd_3_lut_883 (.A(DataToWrite[1]), .B(TempData_3__N_110[2]), 
         .C(DataToWrite[5]), .Z(n1144)) /* synthesis lut_function=(A ((C)+!B)+!A (B (C))) */ ;
    defparam TempData_3__N_110_3__bdd_3_lut_883.init = 16'he2e2;
    PFUMX i876 (.BLUT(n1127), .ALUT(n1126), .C0(TempData_3__N_110[4]), 
          .Z(n1128));
    \StrobeGenerator(CLOCK_HZ=14000000,PERIOD_US=1000)  StrobeGenerator0 (.Reset_c(Reset_c), 
            .Reset_N_10(Reset_N_10), .GND_net(GND_net), .Clock(Clock), 
            .SwitchCathode_o(SwitchCathode_o)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(35[4] 40[3])
    Decoder7seg Decoder7seg0 (.n37(n37), .Segments_o_c_6(Segments_o_c_6), 
            .Segments_o_c_3(Segments_o_c_3), .TempData({TempData}), .Segments_o_c_0(Segments_o_c_0), 
            .Segments_o_c_2(Segments_o_c_2), .Segments_o_c_4(Segments_o_c_4), 
            .Segments_o_c_5(Segments_o_c_5), .Segments_o_c_1(Segments_o_c_1)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/display_multiplex.v(71[4] 75[3])
    
endmodule
//
// Verilog Description of module \StrobeGenerator(CLOCK_HZ=14000000,PERIOD_US=1000) 
//

module \StrobeGenerator(CLOCK_HZ=14000000,PERIOD_US=1000)  (Reset_c, Reset_N_10, 
            GND_net, Clock, SwitchCathode_o) /* synthesis syn_module_defined=1 */ ;
    input Reset_c;
    output Reset_N_10;
    input GND_net;
    input Clock;
    output SwitchCathode_o;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [13:0]Counter;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(21[18:25])
    
    wire n15, n16, n24, n18, n773;
    wire [13:0]n5;
    
    wire n774, n21, n26, Strobe_o_N_150, n778, n772, n775, n776, 
        n777;
    
    LUT4 Reset_I_0_1_lut (.A(Reset_c), .Z(Reset_N_10)) /* synthesis lut_function=(!(A)) */ ;   // c:/lattice/kurs15/impl1/source/top.v(78[6:12])
    defparam Reset_I_0_1_lut.init = 16'h5555;
    LUT4 i1_2_lut (.A(Counter[1]), .B(Counter[2]), .Z(n15)) /* synthesis lut_function=(A+(B)) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i1_2_lut.init = 16'heeee;
    LUT4 i2_2_lut (.A(Counter[7]), .B(Counter[6]), .Z(n16)) /* synthesis lut_function=(A+(B)) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i2_2_lut.init = 16'heeee;
    LUT4 i10_4_lut (.A(Counter[0]), .B(Counter[10]), .C(Counter[13]), 
         .D(Counter[9]), .Z(n24)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i10_4_lut.init = 16'hfffe;
    LUT4 i4_2_lut (.A(Counter[3]), .B(Counter[5]), .Z(n18)) /* synthesis lut_function=(A+(B)) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i4_2_lut.init = 16'heeee;
    CCU2D sub_6_add_2_5 (.A0(Counter[3]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[4]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n773), .COUT(n774), .S0(n5[3]), .S1(n5[4]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_5.INIT0 = 16'h5555;
    defparam sub_6_add_2_5.INIT1 = 16'h5555;
    defparam sub_6_add_2_5.INJECT1_0 = "NO";
    defparam sub_6_add_2_5.INJECT1_1 = "NO";
    LUT4 i845_4_lut (.A(n21), .B(n26), .C(n15), .D(n16), .Z(Strobe_o_N_150)) /* synthesis lut_function=(!(A+(B+(C+(D))))) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i845_4_lut.init = 16'h0001;
    FD1S3JX Counter_i0 (.D(n5[0]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[0])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i0.GSR = "ENABLED";
    FD1S3AX Strobe_o_15 (.D(Strobe_o_N_150), .CK(Clock), .Q(SwitchCathode_o)) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Strobe_o_15.GSR = "ENABLED";
    FD1S3JX Counter_i13 (.D(n5[13]), .CK(Clock), .PD(Strobe_o_N_150), 
            .Q(Counter[13])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i13.GSR = "ENABLED";
    LUT4 i7_2_lut (.A(Counter[4]), .B(Counter[11]), .Z(n21)) /* synthesis lut_function=(A+(B)) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i7_2_lut.init = 16'heeee;
    FD1S3JX Counter_i12 (.D(n5[12]), .CK(Clock), .PD(Strobe_o_N_150), 
            .Q(Counter[12])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i12.GSR = "ENABLED";
    FD1S3IX Counter_i11 (.D(n5[11]), .CK(Clock), .CD(Strobe_o_N_150), 
            .Q(Counter[11])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i11.GSR = "ENABLED";
    FD1S3JX Counter_i10 (.D(n5[10]), .CK(Clock), .PD(Strobe_o_N_150), 
            .Q(Counter[10])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i10.GSR = "ENABLED";
    FD1S3JX Counter_i9 (.D(n5[9]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[9])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i9.GSR = "ENABLED";
    FD1S3IX Counter_i8 (.D(n5[8]), .CK(Clock), .CD(Strobe_o_N_150), .Q(Counter[8])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i8.GSR = "ENABLED";
    FD1S3JX Counter_i7 (.D(n5[7]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[7])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i7.GSR = "ENABLED";
    FD1S3IX Counter_i6 (.D(n5[6]), .CK(Clock), .CD(Strobe_o_N_150), .Q(Counter[6])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i6.GSR = "ENABLED";
    FD1S3JX Counter_i5 (.D(n5[5]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[5])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i5.GSR = "ENABLED";
    FD1S3IX Counter_i4 (.D(n5[4]), .CK(Clock), .CD(Strobe_o_N_150), .Q(Counter[4])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i4.GSR = "ENABLED";
    FD1S3JX Counter_i3 (.D(n5[3]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[3])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i3.GSR = "ENABLED";
    FD1S3JX Counter_i2 (.D(n5[2]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[2])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i2.GSR = "ENABLED";
    FD1S3JX Counter_i1 (.D(n5[1]), .CK(Clock), .PD(Strobe_o_N_150), .Q(Counter[1])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=35, LSE_RLINE=40 */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(27[12] 37[6])
    defparam Counter_i1.GSR = "ENABLED";
    CCU2D sub_6_add_2_15 (.A0(Counter[13]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(GND_net), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .CIN(n778), .S0(n5[13]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_15.INIT0 = 16'h5555;
    defparam sub_6_add_2_15.INIT1 = 16'h0000;
    defparam sub_6_add_2_15.INJECT1_0 = "NO";
    defparam sub_6_add_2_15.INJECT1_1 = "NO";
    LUT4 i12_4_lut (.A(Counter[12]), .B(n24), .C(n18), .D(Counter[8]), 
         .Z(n26)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // c:/lattice/kurs15/impl1/source/strobe_generator.v(28[7:15])
    defparam i12_4_lut.init = 16'hfffe;
    CCU2D sub_6_add_2_1 (.A0(GND_net), .B0(GND_net), .C0(GND_net), .D0(GND_net), 
          .A1(Counter[0]), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .COUT(n772), .S1(n5[0]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_1.INIT0 = 16'hF000;
    defparam sub_6_add_2_1.INIT1 = 16'h5555;
    defparam sub_6_add_2_1.INJECT1_0 = "NO";
    defparam sub_6_add_2_1.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_9 (.A0(Counter[7]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[8]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n775), .COUT(n776), .S0(n5[7]), .S1(n5[8]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_9.INIT0 = 16'h5555;
    defparam sub_6_add_2_9.INIT1 = 16'h5555;
    defparam sub_6_add_2_9.INJECT1_0 = "NO";
    defparam sub_6_add_2_9.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_11 (.A0(Counter[9]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[10]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n776), .COUT(n777), .S0(n5[9]), .S1(n5[10]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_11.INIT0 = 16'h5555;
    defparam sub_6_add_2_11.INIT1 = 16'h5555;
    defparam sub_6_add_2_11.INJECT1_0 = "NO";
    defparam sub_6_add_2_11.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_3 (.A0(Counter[1]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[2]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n772), .COUT(n773), .S0(n5[1]), .S1(n5[2]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_3.INIT0 = 16'h5555;
    defparam sub_6_add_2_3.INIT1 = 16'h5555;
    defparam sub_6_add_2_3.INJECT1_0 = "NO";
    defparam sub_6_add_2_3.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_13 (.A0(Counter[11]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[12]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n777), .COUT(n778), .S0(n5[11]), .S1(n5[12]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_13.INIT0 = 16'h5555;
    defparam sub_6_add_2_13.INIT1 = 16'h5555;
    defparam sub_6_add_2_13.INJECT1_0 = "NO";
    defparam sub_6_add_2_13.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_7 (.A0(Counter[5]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[6]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n774), .COUT(n775), .S0(n5[5]), .S1(n5[6]));   // c:/lattice/kurs15/impl1/source/strobe_generator.v(32[17:31])
    defparam sub_6_add_2_7.INIT0 = 16'h5555;
    defparam sub_6_add_2_7.INIT1 = 16'h5555;
    defparam sub_6_add_2_7.INJECT1_0 = "NO";
    defparam sub_6_add_2_7.INJECT1_1 = "NO";
    
endmodule
//
// Verilog Description of module Decoder7seg
//

module Decoder7seg (n37, Segments_o_c_6, Segments_o_c_3, TempData, Segments_o_c_0, 
            Segments_o_c_2, Segments_o_c_4, Segments_o_c_5, Segments_o_c_1) /* synthesis syn_module_defined=1 */ ;
    input n37;
    output Segments_o_c_6;
    output Segments_o_c_3;
    input [3:0]TempData;
    output Segments_o_c_0;
    output Segments_o_c_2;
    output Segments_o_c_4;
    output Segments_o_c_5;
    output Segments_o_c_1;
    
    wire [6:0]Segments_o_6__N_151;
    
    wire n1176, n1171, n1149;
    
    LUT4 i458_2_lut (.A(Segments_o_6__N_151[6]), .B(n37), .Z(Segments_o_c_6)) /* synthesis lut_function=(!((B)+!A)) */ ;   // c:/lattice/kurs15/impl1/source/decoder_7seg.v(36[4:13])
    defparam i458_2_lut.init = 16'h2222;
    LUT4 n1176_bdd_2_lut (.A(n1176), .B(n37), .Z(Segments_o_c_3)) /* synthesis lut_function=(!((B)+!A)) */ ;
    defparam n1176_bdd_2_lut.init = 16'h2222;
    LUT4 TempData_2__bdd_4_lut (.A(TempData[2]), .B(TempData[0]), .C(TempData[1]), 
         .D(TempData[3]), .Z(n1176)) /* synthesis lut_function=(!(A (B (C)+!B !(C+(D)))+!A !(B (C+(D))+!B !(C (D))))) */ ;
    defparam TempData_2__bdd_4_lut.init = 16'h6f79;
    LUT4 n1171_bdd_2_lut (.A(n1171), .B(n37), .Z(Segments_o_c_0)) /* synthesis lut_function=(!((B)+!A)) */ ;
    defparam n1171_bdd_2_lut.init = 16'h2222;
    LUT4 TempData_1__bdd_4_lut_892 (.A(TempData[1]), .B(TempData[0]), .C(TempData[3]), 
         .D(TempData[2]), .Z(Segments_o_6__N_151[5])) /* synthesis lut_function=(A (B (C)+!B (C+(D)))+!A !(B (C (D)+!C !(D)))) */ ;
    defparam TempData_1__bdd_4_lut_892.init = 16'hb7f1;
    LUT4 i462_2_lut (.A(Segments_o_6__N_151[2]), .B(n37), .Z(Segments_o_c_2)) /* synthesis lut_function=(!((B)+!A)) */ ;   // c:/lattice/kurs15/impl1/source/decoder_7seg.v(36[4:13])
    defparam i462_2_lut.init = 16'h2222;
    LUT4 TempData_1__bdd_4_lut (.A(TempData[1]), .B(TempData[0]), .C(TempData[3]), 
         .D(TempData[2]), .Z(n1171)) /* synthesis lut_function=(A (((D)+!C)+!B)+!A !(B (C (D)+!C !(D))+!B !(C+!(D)))) */ ;
    defparam TempData_1__bdd_4_lut.init = 16'hbe7b;
    LUT4 Data_i_3__I_0_Mux_2_i15_4_lut (.A(TempData[1]), .B(TempData[0]), 
         .C(TempData[3]), .D(TempData[2]), .Z(Segments_o_6__N_151[2])) /* synthesis lut_function=(!(A (B (C (D))+!B (C (D)+!C !(D)))+!A !(B+!(C (D))))) */ ;   // c:/lattice/kurs15/impl1/source/decoder_7seg.v(16[4] 34[11])
    defparam Data_i_3__I_0_Mux_2_i15_4_lut.init = 16'h4ffd;
    LUT4 i460_2_lut (.A(Segments_o_6__N_151[4]), .B(n37), .Z(Segments_o_c_4)) /* synthesis lut_function=(!((B)+!A)) */ ;   // c:/lattice/kurs15/impl1/source/decoder_7seg.v(36[4:13])
    defparam i460_2_lut.init = 16'h2222;
    LUT4 TempData_0__bdd_4_lut (.A(TempData[0]), .B(TempData[3]), .C(TempData[1]), 
         .D(TempData[2]), .Z(Segments_o_6__N_151[4])) /* synthesis lut_function=(A (B (C+(D)))+!A (B+(C+!(D)))) */ ;
    defparam TempData_0__bdd_4_lut.init = 16'hdcd5;
    LUT4 TempData_3__bdd_4_lut (.A(TempData[3]), .B(TempData[1]), .C(TempData[0]), 
         .D(TempData[2]), .Z(Segments_o_6__N_151[6])) /* synthesis lut_function=(A (B+(C+!(D)))+!A !(B (C (D))+!B !(D))) */ ;
    defparam TempData_3__bdd_4_lut.init = 16'hbdee;
    LUT4 i459_2_lut (.A(Segments_o_6__N_151[5]), .B(n37), .Z(Segments_o_c_5)) /* synthesis lut_function=(!((B)+!A)) */ ;   // c:/lattice/kurs15/impl1/source/decoder_7seg.v(36[4:13])
    defparam i459_2_lut.init = 16'h2222;
    LUT4 TempData_2__bdd_4_lut_893 (.A(TempData[2]), .B(TempData[0]), .C(TempData[3]), 
         .D(TempData[1]), .Z(n1149)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B (C+(D)))+!A (B (C (D))))) */ ;
    defparam TempData_2__bdd_4_lut_893.init = 16'h1dd7;
    LUT4 n1149_bdd_2_lut (.A(n1149), .B(n37), .Z(Segments_o_c_1)) /* synthesis lut_function=(!((B)+!A)) */ ;
    defparam n1149_bdd_2_lut.init = 16'h2222;
    
endmodule
//
// Verilog Description of module Encoder_U1
//

module Encoder_U1 (n182, Clock, Encoder1S_i_c, n184, AddressDecrement, 
            n1042, AddressIncrement, n1045, ButtonState_o, Encoder1A_i_c_2, 
            Encoder1B_i_c_1, Previous) /* synthesis syn_module_defined=1 */ ;
    output [3:0]n182;
    input Clock;
    input Encoder1S_i_c;
    output n184;
    output AddressDecrement;
    input n1042;
    output AddressIncrement;
    input n1045;
    output ButtonState_o;
    input Encoder1A_i_c_2;
    input Encoder1B_i_c_1;
    output Previous;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [2:0]Sync_o;   // c:/lattice/kurs15/impl1/source/synchronizer.v(10[26:32])
    
    wire n1184, n608, n602;
    wire [2:0]Async_i;   // c:/lattice/kurs15/impl1/source/synchronizer.v(9[26:33])
    wire [3:0]n182_c;
    
    wire n968, n924, n922, Increment_o_N_63, n1182, n1183;
    
    LUT4 i1_4_lut (.A(Sync_o[2]), .B(n1184), .C(n182[3]), .D(Sync_o[1]), 
         .Z(n608)) /* synthesis lut_function=(A (B+(C (D)))+!A (B)) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut.init = 16'heccc;
    FD1S3AX State_FSM_i3 (.D(n602), .CK(Clock), .Q(n182[3]));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i3.GSR = "ENABLED";
    LUT4 AsyncS_i_I_0_1_lut (.A(Encoder1S_i_c), .Z(Async_i[0])) /* synthesis lut_function=(!(A)) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(28[33:42])
    defparam AsyncS_i_I_0_1_lut.init = 16'h5555;
    LUT4 i2_3_lut (.A(n182[1]), .B(n182_c[0]), .C(n184), .Z(n968)) /* synthesis lut_function=(A+(B+(C))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i2_3_lut.init = 16'hfefe;
    FD1S3AX State_FSM_i2 (.D(n924), .CK(Clock), .Q(n184));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i2.GSR = "ENABLED";
    FD1S3AX State_FSM_i1 (.D(n922), .CK(Clock), .Q(n182[1]));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i1.GSR = "ENABLED";
    FD1S3AY State_FSM_i0 (.D(n608), .CK(Clock), .Q(n182_c[0]));   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam State_FSM_i0.GSR = "ENABLED";
    FD1P3IX Decrement_o_40 (.D(n1042), .SP(Increment_o_N_63), .CD(n182[3]), 
            .CK(Clock), .Q(AddressDecrement)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=10, LSE_RCOL=3, LSE_LLINE=32, LSE_RLINE=43 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(45[12] 85[6])
    defparam Decrement_o_40.GSR = "ENABLED";
    LUT4 i842_2_lut (.A(Sync_o[2]), .B(Sync_o[1]), .Z(Increment_o_N_63)) /* synthesis lut_function=(!(A+(B))) */ ;
    defparam i842_2_lut.init = 16'h1111;
    FD1P3IX Increment_o_39 (.D(n1045), .SP(Increment_o_N_63), .CD(n182[3]), 
            .CK(Clock), .Q(AddressIncrement)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=10, LSE_RCOL=3, LSE_LLINE=32, LSE_RLINE=43 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(45[12] 85[6])
    defparam Increment_o_39.GSR = "ENABLED";
    PFUMX i896 (.BLUT(n1182), .ALUT(n1183), .C0(n184), .Z(n1184));
    LUT4 i1_4_lut_adj_2 (.A(n182[3]), .B(Sync_o[1]), .C(Sync_o[2]), .D(n968), 
         .Z(n602)) /* synthesis lut_function=(!(A (B (C))+!A (B+(C+!(D))))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_2.init = 16'h2b2a;
    LUT4 i1_4_lut_adj_3 (.A(n182_c[0]), .B(n184), .C(Sync_o[1]), .D(Sync_o[2]), 
         .Z(n924)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B ((D)+!C))+!A ((C (D)+!C !(D))+!B))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_3.init = 16'h0ce0;
    LUT4 i1_4_lut_adj_4 (.A(n182_c[0]), .B(n182[1]), .C(Sync_o[1]), .D(Sync_o[2]), 
         .Z(n922)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B (C+!(D)))+!A ((C (D)+!C !(D))+!B))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(46[4] 84[11])
    defparam i1_4_lut_adj_4.init = 16'h0ec0;
    LUT4 i1_4_lut_then_2_lut (.A(Sync_o[2]), .B(Sync_o[1]), .Z(n1183)) /* synthesis lut_function=(A (B)) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(53[15] 55[9])
    defparam i1_4_lut_then_2_lut.init = 16'h8888;
    LUT4 i1_4_lut_else_2_lut (.A(Sync_o[2]), .B(n182_c[0]), .C(Sync_o[1]), 
         .D(n182[1]), .Z(n1182)) /* synthesis lut_function=(A (B (C)+!B (C (D)))) */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(53[15] 55[9])
    defparam i1_4_lut_else_2_lut.init = 16'ha080;
    \Synchronizer(WIDTH=3)_U0  SynchronizerA (.Sync_o({Sync_o[2:1], ButtonState_o}), 
            .Clock(Clock), .AsyncS_i_N_67(Async_i[0]), .Encoder1A_i_c_2(Encoder1A_i_c_2), 
            .Encoder1B_i_c_1(Encoder1B_i_c_1)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(25[4] 30[3])
    EdgeDetector EdgeDetector_inst (.Previous(Previous), .Clock(Clock), 
            .ButtonState_o(ButtonState_o)) /* synthesis syn_module_defined=1 */ ;   // c:/lattice/kurs15/impl1/source/encoder.v(89[15] 95[3])
    
endmodule
//
// Verilog Description of module \Synchronizer(WIDTH=3)_U0 
//

module \Synchronizer(WIDTH=3)_U0  (Sync_o, Clock, AsyncS_i_N_67, Encoder1A_i_c_2, 
            Encoder1B_i_c_1) /* synthesis syn_module_defined=1 */ ;
    output [2:0]Sync_o;
    input Clock;
    input AsyncS_i_N_67;
    input Encoder1A_i_c_2;
    input Encoder1B_i_c_1;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    wire [2:0]R1;   // c:/lattice/kurs15/impl1/source/synchronizer.v(13[18:20])
    
    FD1S3AX R2_i0 (.D(R1[0]), .CK(Clock), .Q(Sync_o[0])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R2_i0.GSR = "ENABLED";
    FD1S3AX R1_i0 (.D(AsyncS_i_N_67), .CK(Clock), .Q(R1[0])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R1_i0.GSR = "ENABLED";
    FD1S3AX R1_i2 (.D(Encoder1A_i_c_2), .CK(Clock), .Q(R1[2])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R1_i2.GSR = "ENABLED";
    FD1S3AX R1_i1 (.D(Encoder1B_i_c_1), .CK(Clock), .Q(R1[1])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R1_i1.GSR = "ENABLED";
    FD1S3AX R2_i2 (.D(R1[2]), .CK(Clock), .Q(Sync_o[2])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R2_i2.GSR = "ENABLED";
    FD1S3AX R2_i1 (.D(R1[1]), .CK(Clock), .Q(Sync_o[1])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=25, LSE_RLINE=30 */ ;   // c:/lattice/kurs15/impl1/source/synchronizer.v(20[12] 23[6])
    defparam R2_i1.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module EdgeDetector
//

module EdgeDetector (Previous, Clock, ButtonState_o) /* synthesis syn_module_defined=1 */ ;
    output Previous;
    input Clock;
    input ButtonState_o;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    
    FD1S3AX Previous_13 (.D(ButtonState_o), .CK(Clock), .Q(Previous)) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=15, LSE_RCOL=3, LSE_LLINE=89, LSE_RLINE=95 */ ;   // c:/lattice/kurs15/impl1/source/edge_detector.v(18[4:25])
    defparam Previous_13.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module PUR
// module not written out since it is a black-box. 
//

//
// Verilog Description of module \RAM(ADDRESS_WIDTH=8) 
//

module \RAM(ADDRESS_WIDTH=8)  (Address, DataToWrite, DataReadFromMemory, 
            Clock, VCC_net, Reset_N_10, GND_net, ButtonState_o, Previous, 
            Reset_c) /* synthesis syn_module_defined=1 */ ;
    input [7:0]Address;
    input [7:0]DataToWrite;
    output [7:0]DataReadFromMemory;
    input Clock;
    input VCC_net;
    input Reset_N_10;
    input GND_net;
    input ButtonState_o;
    input Previous;
    input Reset_c;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // c:/lattice/kurs15/impl1/source/top.v(18[7:12])
    
    wire Memory_N_98;
    
    SP8KC Memory0 (.DI0(DataToWrite[0]), .DI1(DataToWrite[1]), .DI2(DataToWrite[2]), 
          .DI3(DataToWrite[3]), .DI4(DataToWrite[4]), .DI5(DataToWrite[5]), 
          .DI6(DataToWrite[6]), .DI7(DataToWrite[7]), .DI8(GND_net), .AD0(VCC_net), 
          .AD1(GND_net), .AD2(GND_net), .AD3(Address[0]), .AD4(Address[1]), 
          .AD5(Address[2]), .AD6(Address[3]), .AD7(Address[4]), .AD8(Address[5]), 
          .AD9(Address[6]), .AD10(Address[7]), .AD11(GND_net), .AD12(GND_net), 
          .CE(VCC_net), .OCE(VCC_net), .CLK(Clock), .WE(Memory_N_98), 
          .CS0(GND_net), .CS1(GND_net), .CS2(GND_net), .RST(Reset_N_10), 
          .DO0(DataReadFromMemory[0]), .DO1(DataReadFromMemory[1]), .DO2(DataReadFromMemory[2]), 
          .DO3(DataReadFromMemory[3]), .DO4(DataReadFromMemory[4]), .DO5(DataReadFromMemory[5]), 
          .DO6(DataReadFromMemory[6]), .DO7(DataReadFromMemory[7]));
    defparam Memory0.DATA_WIDTH = 9;
    defparam Memory0.REGMODE = "NOREG";
    defparam Memory0.CSDECODE = "0b000";
    defparam Memory0.WRITEMODE = "READBEFOREWRITE";
    defparam Memory0.GSR = "DISABLED";
    defparam Memory0.RESETMODE = "ASYNC";
    defparam Memory0.ASYNC_RESET_RELEASE = "ASYNC";
    defparam Memory0.INIT_DATA = "STATIC";
    defparam Memory0.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    defparam Memory0.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000";
    LUT4 i2_3_lut (.A(ButtonState_o), .B(Previous), .C(Reset_c), .Z(Memory_N_98)) /* synthesis lut_function=(!((B+!(C))+!A)) */ ;   // c:/lattice/kurs15/impl1/source/ram.v(39[12] 44[6])
    defparam i2_3_lut.init = 16'h2020;
    
endmodule
